pub mod bin_cue;

use bin_cue::BinCueWriter;
use super::types::CDDesc;
use std::path::PathBuf;
use tool_helper::{Error, open_output_file};

pub enum ImageType {
    BinCue
}

pub trait SectorWriter {
    fn write(&mut self)            -> Result<(), Error>;
    fn sector_written_count(&self) -> usize;
}

pub fn write_image(_cd_desc: CDDesc, image_type: ImageType, output_path: PathBuf) -> Result<(), Error> {
    match image_type {
        ImageType::BinCue => {
            let mut _writer = BinCueWriter::new(open_output_file(output_path)?);

            Ok(())
        }
    }
}